## libinsane 1.0.3

=== Makefile ===
PYTHON ?= python3
VERBOSE ?=
PREFIX ?= /usr/local

SRCS = $(wildcard src/libinsane/*.c)
HEADERS = $(wildcard include/libinsane/*.h)

all: build check test

build: build_c build_py

install: install_py install_c

uninstall: uninstall_py uninstall_c

build_py:

build/build.ninja:
	mkdir -p build
	(cd build && meson --werror --warnlevel 2 --prefix=${PREFIX} ..)

build_c: build/build.ninja
	(cd build && ninja)

version:

doc: build/build.ninja
	# Libinsane doc
	(cd build && ninja subprojects/libinsane/doc/doc_out)
	# Libinsane-gobject doc (Meson 0.37.1 || Meson 0.47.1)
	(cd build ; ninja libinsane-gobject-doc || ninja libinsane-gobject@@libinsane-gobject-doc)
	rm -rf doc/build
	mkdir -p doc/build
	mv build/doc/html doc/build/libinsane
	mv build/subprojects/libinsane-gobject/doc/html doc/build/libinsane-gobject
	cp doc/index.html doc/build
	echo "Documentation is available in doc/build/"

check: build_c
	! command -v sparse || python3 ./check_sparse.py build/compile_commands.json
	# Debian / Ubuntu
	(cd build ; ! command -v run-clang-tidy-4.0.py || ! (run-clang-tidy-4.0.py | grep warning 2>&1))
	(cd build ; ! command -v run-clang-tidy-7 || ! (run-clang-tidy-7 | grep warning 2>&1))
	# Fedora
	(cd build ; [ ! -f /usr/share/clang/run-clang-tidy.py ] || ! (/usr/share/clang/run-clang-tidy.py | grep warning 2>&1))

test: build/build.ninja
	(cd build && ninja test)

test_hw:
	rm -rf test_hw_out
	subprojects/libinsane-gobject/tests/test_hw.py test_hw_out

linux_exe:

windows_exe:

release:
ifeq (${RELEASE}, )
	@echo "You must specify a release version ($(MAKE) release RELEASE=1.2.3)"
else
	@echo "Will release: ${RELEASE}"
	@echo "Checking release is in ChangeLog ..."
	grep ${RELEASE} ChangeLog
	@echo "Checking release is in meson.build ..."
	grep ${RELEASE} meson.build
	@echo "Checking release is in subprojects/libinsane/meson.build ..."
	grep ${RELEASE} subprojects/libinsane/meson.build
	@echo "Checking release is in subprojects/libinsane-gobject/meson.build ..."
	grep ${RELEASE} subprojects/libinsane-gobject/meson.build
	@echo "Releasing ..."
	git tag -a ${RELEASE} -m ${RELEASE}
	git push origin ${RELEASE}
	@echo "All done"
endif

clean:
	rm -rf build
	rm -rf doc/build
	rm -rf subprojects/libinsane-gobject/generated
	mkdir -p subprojects/libinsane-gobject/generated
	touch subprojects/libinsane-gobject/generated/.notempty

install_py:

install_c: build/build.ninja
	(cd build && ninja install)

uninstall_py:

uninstall_c:
	(cd build && ninja uninstall)

help:
	@echo "make build || make build_c || make build_py"
	@echo "make check"
	@echo "make doc"
	@echo "make help: display this message"
	@echo "make install || make install_py"
	@echo "make release"
	@echo "make test"
	@echo "make uninstall || make uninstall_py"

.PHONY: \
	build \
	build_c \
	build_py \
	check \
	doc \
	linux_exe \
	windows_exe \
	help \
	install \
	install_c \
	install_py \
	release \
	test \
	uninstall \
	uninstall_c \
	uninstall_py \
	version

=== debian/changelog ===
libinsane (1.0.3-1) unstable; urgency=medium

  * New upstream version 1.0.3
  * debian/patches: cheery-pick upstream commit to fix Debian build

 -- Thomas Perret <thomas.perret@phyx.fr>  Mon, 23 Dec 2019 15:16:10 +0100

libinsane (1.0.2-2) unstable; urgency=medium

  * debian/rules: Use meson buildsystem directly instead of included Makefile
  * debian/control: Enable unit tests at build time

 -- Thomas Perret <thomas.perret@phyx.fr>  Wed, 11 Dec 2019 22:16:42 +0100

libinsane (1.0.2-1) unstable; urgency=medium

  * New upstream version 1.0.2
  * debian:
    - Add Salsa CI jobs
    - Add symbol from 1.0.2
    - Bump Standards-Version to 4.4.1 (no changes needed)
    - Add Multi-Arch: foreign to doc package

 -- Thomas Perret <thomas.perret@phyx.fr>  Tue, 26 Nov 2019 13:46:24 +0100

libinsane (1.0.1-1) unstable; urgency=medium

  * Initial release (Closes: #940962)

 -- Thomas Perret <thomas.perret@phyx.fr>  Mon, 26 Aug 2019 17:53:03 +0200

=== debian/control ===
Source: libinsane
Priority: optional
Maintainer: Thomas Perret <thomas.perret@phyx.fr>
Build-Depends: debhelper-compat (= 12), meson, libsane-dev, libgirepository1.0-dev, gobject-introspection, python3-gi, valac, gtk-doc-tools, libcunit1-dev
Standards-Version: 4.4.1
Section: libs
Homepage: https://gitlab.gnome.org/World/OpenPaperwork/libinsane
Vcs-Browser: https://salsa.debian.org/openpaperwork-team/libinsane
Vcs-Git: https://salsa.debian.org/openpaperwork-team/libinsane.git
Rules-Requires-Root: no

Package: libinsane-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libinsane1 (= ${binary:Version}),
         gir1.2-libinsane-1.0 (= ${binary:Version}),
         ${misc:Depends}
Description: Library to access scanner - development files
 A cross-platform, cross-programming languages, cross scanner library
 that takes care of all the quirks of scanners.
 .
 This package installs development headers.

Package: libinsane1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to access scanner
 A cross-platform, cross-programming languages, cross scanner library
 that takes care of all the quirks of scanners.
 .
 This package installs library.

Package: gir1.2-libinsane-1.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${gir:Depends}, ${misc:Depends}
Description: Library to access scanner - GObject bindings
 A cross-platform, cross-programming languages, cross scanner library
 that takes care of all the quirks of scanners.
 .
 This package contains the GObject bindings.

Package: libinsane-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Library to access scanner - documentation
 A cross-platform, cross-programming languages, cross scanner library
 that takes care of all the quirks of scanners.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PREFIX=/usr

%:
	dh $@ --with gir

override_dh_auto_configure:
	mkdir -p debian/build
	cd debian/build && meson --werror --warnlevel 3 --prefix=${PREFIX} ../..

override_dh_auto_build:
	cd debian/build && ninja -v

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd debian/build && ninja -v test
endif

override_dh_auto_install:
	cd debian/build && DESTDIR=${CURDIR}/debian/tmp ninja -v install

override_dh_missing:
	dh_missing --fail-missing

=== debian/tests/control ===
Test-Command: python3 /usr/share/doc/gir1.2-libinsane-1.0/examples/list_devices.py
Depends: @, python3, python3-gi
Restrictions: superficial
Features: test-name=gi

Tests: sane
Depends: @, build-essential, libcunit1-dev

Tests: multiplexer, normalizer-all-opts-on-all-sources, normalizer-bmp2raw, normalizer-clean-dev-descs, normalizer-min-one-source, normalizer-opt-aliases, normalizer-raw24, normalizer-resolution, normalizer-safe-defaults, normalizer-source-names, normalizer-source-nodes, normalizer-source-types, workaround-cache, workaround-check-capabilities, workaround-dedicated-thread, workaround-one-page-flatbed, workaround-opt-names, workaround-opt-values
Depends: @, build-essential, libcunit1-dev, valgrind
Restrictions: allow-stderr

## libinsane 1.0.4

=== debian/changelog ===
libinsane (1.0.4-1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.

 -- andyprough <andyprough@protonmail.com>  Sat, 15 Aug 2020 00:42:32 -0500

libinsane (1.0.4-1) unstable; urgency=medium

  * New upstream version 1.0.4
  * debian/patches: Drop patches applied upstream
  * debian/symbols: Add new symbols from new upstream version 1.0.4
  * debian/rules: Use same warnlevel as upstream
  * debian/control: Bump Standards-Version to 4.5.0 (no changes needed)

 -- Thomas Perret <thomas.perret@phyx.fr>  Tue, 17 Mar 2020 00:59:59 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: libinsane
 Priority: optional
-Maintainer: Thomas Perret <thomas.perret@phyx.fr>
+Maintainer: andyprough <andyprough@protonmail.com>
+XSBC-Original-Maintainer: Thomas Perret <thomas.perret@phyx.fr>
 Build-Depends: debhelper-compat (= 12), meson, libsane-dev, libgirepository1.0-dev, gobject-introspection, python3-gi, valac, gtk-doc-tools, libcunit1-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Section: libs
 Homepage: https://gitlab.gnome.org/World/OpenPaperwork/libinsane
 Vcs-Browser: https://salsa.debian.org/openpaperwork-team/libinsane

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 override_dh_auto_configure:
 	mkdir -p debian/build
-	cd debian/build && meson --werror --warnlevel 3 --prefix=${PREFIX} ../..
+	cd debian/build && meson --werror --warnlevel 2 --prefix=${PREFIX} ../..
 
 override_dh_auto_build:
 	cd debian/build && ninja -v
@@ -23,3 +23,6 @@
 
 override_dh_missing:
 	dh_missing --fail-missing
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym

## libinsane 1.0.9

=== Makefile ===
--- 
+++ 
@@ -1,9 +1,17 @@
+UNAME := $(shell uname)
+
 PYTHON ?= python3
 VERBOSE ?=
 PREFIX ?= /usr/local
 
 SRCS = $(wildcard src/libinsane/*.c)
 HEADERS = $(wildcard include/libinsane/*.h)
+
+ifeq ($(UNAME), Linux)
+CFLAGS=-O2 -D_FORTIFY_SOURCE=2
+else
+CFLAGS=
+endif
 
 all: build check test
 
@@ -17,7 +25,9 @@
 
 build/build.ninja:
 	mkdir -p build
-	(cd build && meson --werror --warnlevel 2 --prefix=${PREFIX} ..)
+	echo "Uname: " $(UNAME)
+	echo "CFLAGS: " $(CFLAGS)
+	(cd build && CFLAGS="$(CFLAGS)" meson --werror --warnlevel 2 --prefix=${PREFIX} ..)
 
 build_c: build/build.ninja
 	(cd build && ninja)

=== debian/changelog ===
libinsane (1.0.9-2) unstable; urgency=medium

  * debian/rules: explicitly use meson+ninja build system (remove now
    unnecessary overrides)

 -- Thomas Perret <thomas.perret@phyx.fr>  Tue, 19 Jan 2021 19:57:11 +0100

libinsane (1.0.9-1) unstable; urgency=medium

  * New upstream version 1.0.9
  * Add missing tests for autopkgtests
  * debian/control: Bump Standards-Version (no changes needed)

 -- Thomas Perret <thomas.perret@phyx.fr>  Wed, 06 Jan 2021 15:48:09 +0100

libinsane (1.0.8-1) unstable; urgency=medium

  * New upstream version 1.0.8

 -- Thomas Perret <thomas.perret@phyx.fr>  Sat, 10 Oct 2020 00:37:20 +0200

libinsane (1.0.7-1) unstable; urgency=medium

  * New upstream version 1.0.7
  * Add symbols from 1.0.7
  * debian/control: Bump debhelper compat to 13
  * debian/rules: drop dh_missing override
  * Ignore test build of dh_girepository for blhc checks

 -- Thomas Perret <thomas.perret@phyx.fr>  Thu, 03 Sep 2020 19:08:10 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: libinsane
 Priority: optional
-Maintainer: andyprough <andyprough@protonmail.com>
-XSBC-Original-Maintainer: Thomas Perret <thomas.perret@phyx.fr>
-Build-Depends: debhelper-compat (= 12), meson, libsane-dev, libgirepository1.0-dev, gobject-introspection, python3-gi, valac, gtk-doc-tools, libcunit1-dev
-Standards-Version: 4.5.0
+Maintainer: Thomas Perret <thomas.perret@phyx.fr>
+Build-Depends: debhelper-compat (= 13), meson, libsane-dev, libgirepository1.0-dev, gobject-introspection, python3-gi, valac, gtk-doc-tools, libcunit1-dev
+Standards-Version: 4.5.1
 Section: libs
 Homepage: https://gitlab.gnome.org/World/OpenPaperwork/libinsane
 Vcs-Browser: https://salsa.debian.org/openpaperwork-team/libinsane

=== debian/tests/control ===
Test-Command: python3 /usr/share/doc/gir1.2-libinsane-1.0/examples/list_devices.py
Depends: @, python3, python3-gi
Restrictions: superficial
Features: test-name=gi

Tests: sane
Depends: @, build-essential, libcunit1-dev

Tests: multiplexer, normalizer-all-opts-on-all-sources, normalizer-bmp2raw, normalizer-clean-dev-descs, normalizer-min-one-source, normalizer-opt-aliases, normalizer-raw24, normalizer-resolution, normalizer-safe-defaults, normalizer-source-names, normalizer-source-nodes, normalizer-source-types, workaround-cache, workaround-check-capabilities, workaround-dedicated-thread, workaround-one-page-flatbed, workaround-opt-names, workaround-opt-values workaround-dedicated-process workaround-dedicated-process-pack workaround-lamp
Depends: @, build-essential, libcunit1-dev, valgrind
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/archive\/(\d\S+)\/libinsane.*\.tar\.gz/libinsane-$1\.tar\.gz/g \
  https://gitlab.gnome.org/World/OpenPaperWork/libinsane/tags?sort=updated_desc .*/archive/(\d\S+)/.*\.tar\.gz.*

## libinsane 1.0.10

=== debian/changelog ===
libinsane (1.0.10-4) unstable; urgency=medium

  * debian/tests: disable valgrind for armhf architecture (Closes: #1100939)
  * debian/copyright: Update copyright year
  * debian/control: Bump Standards-Version (no changes needed)

 -- Thomas Perret <thomas.perret@phyx.fr>  Tue, 25 Mar 2025 22:54:12 +0100

libinsane (1.0.10-3) unstable; urgency=medium

  * debian/tests: Run tests with valgrind only on supported arch

 -- Thomas Perret <thomas.perret@phyx.fr>  Sat, 07 Sep 2024 14:38:43 +0200

libinsane (1.0.10-2) unstable; urgency=medium

  * debian/watch: Fix upstream URL checking
  * debian/rules: reduce the limit of allowed file descriptors
  * debian/control:
    + bump Standards-Version to 4.7.0 (no changes needed)
    + Build-Depends on dh-sequence-gir
  * debian/copyright: update copyright years
  * debian/tests:
    + add missing macro when building tests
    + reformat Tests entry

 -- Thomas Perret <thomas.perret@phyx.fr>  Sat, 07 Sep 2024 00:05:51 +0200

libinsane (1.0.10-1) unstable; urgency=medium

  * New upstream version 1.0.10
  * debian/symbols:
    + Add symbols from 1.0.10
    + Add Build-Depends-Package field to libinsane_gobject library's symbols
  * debian/control: Bumps Standards-Version to 4.6.2 (no changes needed)
  * debian/tests: Add new unittests
  * debian/copyright: update copyright year
  * debian/rules: Ignore arch-triplet for blhc checks override

 -- Thomas Perret <thomas.perret@phyx.fr>  Sun, 03 Dec 2023 14:24:31 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,17 @@
 Source: libinsane
 Priority: optional
 Maintainer: Thomas Perret <thomas.perret@phyx.fr>
-Build-Depends: debhelper-compat (= 13), meson, libsane-dev, libgirepository1.0-dev, gobject-introspection, python3-gi, valac, gtk-doc-tools, libcunit1-dev
-Standards-Version: 4.5.1
+Build-Depends:
+ debhelper-compat (= 13),
+ meson,
+ libsane-dev,
+ dh-sequence-gir,
+ gir1.2-glib-2.0-dev,
+ python3-gi,
+ valac,
+ gtk-doc-tools,
+ libcunit1-dev,
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://gitlab.gnome.org/World/OpenPaperwork/libinsane
 Vcs-Browser: https://salsa.debian.org/openpaperwork-team/libinsane
@@ -16,6 +25,7 @@
 Depends: libinsane1 (= ${binary:Version}),
          gir1.2-libinsane-1.0 (= ${binary:Version}),
          ${misc:Depends}
+Provides: ${gir:Provides}
 Description: Library to access scanner - development files
  A cross-platform, cross-programming languages, cross scanner library
  that takes care of all the quirks of scanners.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PREFIX=/usr

%:
	dh $@ --with gir --buildsystem=meson+ninja

override_dh_auto_test:
	# dedicated_process workaround tries to close all possible file
	# descriptors and sbuild seems to set it to the hard limit which
	# is 1073741816 on my system and generates timeout
ifeq ($(filter nocheck, $(DEB_BUILD_OPTIONS)),)
	ulimit -Sn
	ulimit -Sn 1024 && dh_auto_test
endif

override_dh_girepository:
	@echo 'blhc: ignore-line-regexp: \s+(\w+-?)*gcc -Wno-implicit-function-declaration -shared -fPIC -o debian/gir.*'
	dh_girepository

=== debian/tests/control ===
Test-Command: python3 /usr/share/doc/gir1.2-libinsane-1.0/examples/list_devices.py
Depends: @, python3, python3-gi
Restrictions: superficial
Features: test-name=gi

Tests: sane
Depends: @, build-essential, libcunit1-dev

Tests:
 multiplexer,
 normalizer-all-opts-on-all-sources,
 normalizer-bmp2raw,
 normalizer-clean-dev-descs,
 normalizer-min-one-source,
 normalizer-opt-aliases,
 normalizer-raw24,
 normalizer-resolution,
 normalizer-safe-defaults,
 normalizer-source-names,
 normalizer-source-nodes,
 normalizer-source-types,
 workaround-cache,
 workaround-check-capabilities,
 workaround-dedicated-thread,
 workaround-one-page-flatbed,
 workaround-opt-names,
 workaround-opt-values,
 workaround-dedicated-process,
 workaround-dedicated-process-pack,
 workaround-lamp,
 workaround-hide-source-auto,
 workaround-invalid-page-size,
Depends: @, build-essential, libcunit1-dev, valgrind [amd64 arm64 i386 mips mips64 mips64el mipsel powerpc ppc64 ppc64el s390x]
Restrictions: allow-stderr
